]> arthur.barton.de Git - bup.git/blobdiff - t/subtree-hash
test-web: mark as unresolved with respect to python 3
[bup.git] / t / subtree-hash
index 691c207be6f9806206777fd94eb13414ca344af9..1ca9e869c84a0dab1e5ce1ee647cb391170b9947 100755 (executable)
@@ -1,20 +1,19 @@
-#!/usr/bin/env python
-
-import os, sys
-
-argv = sys.argv
-exe = os.path.realpath(argv[0])
-exepath = os.path.split(exe)[0] or '.'
-exeprefix = os.path.split(os.path.abspath(exepath))[0]
+#!/bin/sh
+"""": # -*-python-*-
+bup_python="$(dirname "$0")/../cmd/bup-python" || exit $?
+exec "$bup_python" "$0" ${1+"$@"}
+"""
+# end of bup preamble
 
-# fix the PYTHONPATH to include our lib dir
-libpath = os.path.join(exepath, '..', 'lib')
-sys.path[:0] = [libpath]
-os.environ['PYTHONPATH'] = libpath + ':' + os.environ.get('PYTHONPATH', '')
+from __future__ import absolute_import, print_function
+import sys
 
+from bup.compat import argv_bytes
 from bup.helpers import handle_ctrl_c, readpipe
+from bup.io import byte_stream
 from bup import options
 
+
 optspec = """
 subtree-hash ROOT_HASH [PATH_ITEM...]
 --
@@ -28,22 +27,23 @@ o = options.Options(optspec)
 if len(extra) < 1:
     o.fatal('must specify a root hash')
 
-tree_hash = extra[0]
-path = extra[1:]
+tree_hash = argv_bytes(extra[0])
+path = [argv_bytes(x) for x in extra[1:]]
 
 while path:
     target_name = path[0]
-    subtree_items = readpipe(['git', 'ls-tree', '-z', tree_hash])
+    subtree_items = readpipe([b'git', b'ls-tree', b'-z', tree_hash])
     target_hash = None
-    for entry in subtree_items.split('\0'):
+    for entry in subtree_items.split(b'\0'):
         if not entry:
             break
-        info, name = entry.split('\t', 1)
+        info, name = entry.split(b'\t', 1)
         if name == target_name:
-            _, _, target_hash = info.split(' ')
+            _, _, target_hash = info.split(b' ')
             break
     if not target_hash:
-        print >> sys.stderr, "Can't find %r in %s" % (target_name, tree_hash)
+        print("Can't find %r in %s" % (target_name, tree_hash.decode('ascii')),
+              file=sys.stderr)
         break
     tree_hash = target_hash
     path = path[1:]
@@ -51,4 +51,6 @@ while path:
 if path:
     sys.exit(1)
 
-print tree_hash
+sys.stdout.flush()
+out = byte_stream(sys.stdout)
+out.write(tree_hash + b'\n')